!***********************************************************************
!*   
!*   Licensed Materials - Property of IBM.
!*   IBM XL Fortran Advanced Edition V10.1 for Linux (5724-M17)
!*   (C) Copyright IBM Corp. 2003, 2006.
!*   All Rights Reserved.
!*   US Government Users Restricted Rights - 
!*   Use, duplication or disclosure restricted by 
!*   GSA ADP Schedule Contract with IBM Corp.
!*
!***********************************************************************
!
!            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES
!
! THE SOURCE CODE EXAMPLES PROVIDED BY IBM ARE ONLY INTENDED TO ASSIST IN THE
! DEVELOPMENT OF A WORKING SOFTWARE PROGRAM.  THE SOURCE CODE EXAMPLES DO NOT
! FUNCTION AS WRITTEN:  ADDITIONAL CODE IS REQUIRED.  IN ADDITION, THE SOURCE
! CODE EXAMPLES MAY NOT COMPILE AND/OR BIND SUCCESSFULLY AS WRITTEN.
!
! INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE
! EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS" WITHOUT
! WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT
! LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE
! OF THE SOURCE CODE EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS,
! IS WITH YOU.  SHOULD ANY PART OF THE SOURCE CODE EXAMPLES PROVE
! DEFECTIVE, YOU (AND NOT IBM OR AN AUTHORIZED RISC System/6000* WORKSTATION
! DEALER) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR
! CORRECTION.
!
! IBM does not warrant that the contents of the source code examples, whether
! individually or as one or more groups, will meet your requirements or that
! the source code examples are error-free.
!
! IBM may make improvements and/or changes in the source code examples at
! any time.
!
! Changes may be made periodically to the information in the source code
! examples; these changes may be reported in new editions of the examples.
!
! References in the source code examples to IBM products, programs, or
! services do not imply that IBM intends to make these available in all
! countries in which IBM operates.  Any reference to an IBM licensed
! program in the source code examples is not intended to state or imply
! that only IBM's licensed program may be used.  Any functionally equivalent
! program may be used.
!
! * RISC System/6000 is a trademark of International Business Machines
!   Corporation.

! Sample routine to execute the xl__trbk() user routine.  
!
! Compile with: xlf -qflttrap=zerodiv:enable -qsigtrap

        program fpetest
        call foo
        end

        subroutine foo
        call bar
        end

        subroutine bar
        include 'fexcp.h'
        real*8 zero /0.0d0/    ! prevent compile time arithmetic
 
        call xl__trbk
 
        print *, 1.0d0 / zero

        print *, "This should not be printed."
        end
